use crate::{compositions, repositories};
use beteran_protobuf_rust as bpr;

impl From<&repositories::member_bank_account::models::MemberBankAccount>
  for bpr::models::member_bank_account::MemberBankAccount
{
  fn from(d: &repositories::member_bank_account::models::MemberBankAccount) -> Self {
    bpr::models::member_bank_account::MemberBankAccount {
      id: d.id.to_string(),
      member_id: d.member_id.to_string(),
      bank_id: d.bank_id.to_string(),
      name: d.name.clone(),
      account_number: d.account_number.to_string(),
      exchange_password: d.exchange_password.to_string(),
      memo: d.memo.clone(),
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}

impl From<&compositions::member::models::MemberBankAccountModel>
  for bpr::models::member_bank_account::MemberBankAccountModel
{
  fn from(d: &compositions::member::models::MemberBankAccountModel) -> Self {
    bpr::models::member_bank_account::MemberBankAccountModel {
      id: d.id.to_string(),
      member_id: d.member_id.to_string(),
      bank: Some(bpr::models::bank::Bank::from(&d.bank)),
      name: d.name.clone(),
      account_number: d.account_number.clone(),
      exchange_password: d.exchange_password.clone(),
      memo: d.memo.clone(),
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}
