use crate::compositions;
use crate::repositories;
use beteran_protobuf_rust as bpr;

impl From<&repositories::member_bank_deposit::models::MemberBankDeposit>
  for bpr::models::member_bank_deposit::MemberBankDeposit
{
  fn from(d: &repositories::member_bank_deposit::models::MemberBankDeposit) -> Self {
    bpr::models::member_bank_deposit::MemberBankDeposit {
      id: d.id.to_string(),
      member_id: d.member_id.to_string(),
      name: d.name.clone(),
      amount: d.amount,
      memo: d.memo.clone(),
      state: d.state as i32,
      state_changed_at: d.state_changed_at as u64,
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}

impl From<&compositions::member_bank_deposit::models::MemberBankDepositModel>
  for bpr::models::member_bank_deposit::MemberBankDepositModel
{
  fn from(d: &compositions::member_bank_deposit::models::MemberBankDepositModel) -> Self {
    bpr::models::member_bank_deposit::MemberBankDepositModel {
      id: d.id.to_string(),
      member: Some(bpr::models::member::Member::from(&d.member)),
      name: d.name.clone(),
      amount: d.amount,
      memo: d.memo.clone(),
      state: d.state as i32,
      state_changed_at: d.state_changed_at as u64,
      created_at: d.created_at as u64,
      updated_at: d.updated_at as u64,
    }
  }
}

impl From<i32> for repositories::member_bank_deposit::schema::MemberBankDepositState {
  fn from(s: i32) -> Self {
    match s {
      s if s
        == repositories::member_bank_deposit::schema::MemberBankDepositState::Complete as i32 =>
      {
        repositories::member_bank_deposit::schema::MemberBankDepositState::Complete
      }
      _ => repositories::member_bank_deposit::schema::MemberBankDepositState::Application,
    }
  }
}
